10     DIM Adapter$[9],Meas_para$[5],Swp_para$[9],Swp_type$[9]
20     DIM Bw$[9],Fmt_a$[9],Fmt_b$[9],Spl_disp$[9]
30     DIM Buff$[9],Inp_char$[9]
40     REAL Start,Stop,Imp_val,Freq_val
50     INTEGER Scode,Result
60     CLEAR SCREEN
70     !
80     IF SYSTEM$("SYSTEM ID")="HP4294A" THEN 
90       ASSIGN @Hp4294a TO 800
100      Scode=8
110    ELSE
120      ASSIGN @Hp4294a TO 717
130      Scode=7
140    END IF
150    !
160    Adapter$="OFF"
170    Meas_para$="IMPH"
180    Swp_para$="FREQ"
190    Swp_type$="LOG"
200    Start=100
210    Stop=1.0E+8
220    Bw$="2"
230    Fmt_a$="LOGY"
240    Fmt_b$="LINY"
250    Spl_disp$="ON"
260    !
270    ! Measurement Setting
280    !
290    OUTPUT @Hp4294a;"E4TP "&Adapter$
300    OUTPUT @Hp4294a;"PRES"
310    OUTPUT @Hp4294a;"MEAS "&Meas_para$
320    OUTPUT @Hp4294a;"SWPP "&Swp_para$
330    OUTPUT @Hp4294a;"SWPT "&Swp_type$
340    OUTPUT @Hp4294a;"STAR ";Start
350    OUTPUT @Hp4294a;"STOP ";Stop
360    OUTPUT @Hp4294a;"BWFACT "&Bw$
370    !
380    ! Fixture Compensation (Open/Short)
390    !
400    OUTPUT @Hp4294a;"ESNB 256"
410    OUTPUT @Hp4294a;"*SRE 4"
420    Result=FNFixt_comp(@Hp4294a,Scode,"Open")
430    IF Result<>0 THEN Prog_end
440    Result=FNFixt_comp(@Hp4294a,Scode,"Short")
450    IF Result<>0 THEN Prog_end
460    !
470    ! Display Setting
480    !
490    OUTPUT @Hp4294a;"TRAC A"
500    OUTPUT @Hp4294a;"FMT "&Fmt_a$
510    OUTPUT @Hp4294a;"TRAC B"
520    OUTPUT @Hp4294a;"FMT "&Fmt_b$
530    OUTPUT @Hp4294a;"SPLD "&Spl_disp$
540    !
550 Meas_start: ! Single Sweep Start
560    !
570    PRINT "Set DUT, then Push [Enter] key"
580    INPUT "",Inp_char$
590    !
600    OUTPUT @Hp4294a;"SING"
610    PRINT "Now measuring..."
620    OUTPUT @Hp4294a;"*OPC?"
630    ENTER @Hp4294a;Buff$
640    !
650    ! Auto Scaling
660    !
670    OUTPUT @Hp4294a;"TRAC A"
680    OUTPUT @Hp4294a;"AUTO"
690    OUTPUT @Hp4294a;"TRAC B"
700    OUTPUT @Hp4294a;"AUTO"
710    !
720    ! Minimum Point Search
730    !
740    OUTPUT @Hp4294a;"TRAC A"
750    OUTPUT @Hp4294a;"MKR ON"
760    OUTPUT @Hp4294a;"SEAM MIN"
770    !
780    OUTPUT @Hp4294a;"MKRVAL?"
790    ENTER @Hp4294a;Imp_val
800    OUTPUT @Hp4294a;"MKRPRM?"
810    ENTER @Hp4294a;Freq_val
820    !
830    PRINT "   ## Measurement Result ##"
840    PRINT USING "13A,4D.4D,6A";"  Frequency: ",Freq_val/1.E+6," [MHz]"
850    PRINT USING "13A,4D.4D,6A";"  Impedance: ",Imp_val," [ohm]"
860    PRINT ""
870    !
880    INPUT "Once more? [Y]es/[N]o",Inp_char$
890    IF UPC$(Inp_char$)="Y" OR UPC$(Inp_char$)="YES" THEN Meas_start
900 Prog_end: !
910    END
920    !
930    ! Fixture Compensation Data Measurement Function
940    !
950  DEF FNFixt_comp(@Hp4294a,INTEGER Scode,Standard$)
960    DIM Inp_char$[9],Err_mes$[50]
970    INTEGER Err_no
980    OUTPUT @Hp4294a;"*CLS"
990    PRINT "Set "&Standard$&"-Connection"
1000   INPUT "OK? [Y/N]",Inp_char$
1010   IF UPC$(Inp_char$)="Y" THEN 
1020     ON INTR Scode GOTO Meas_end
1030     ENABLE INTR Scode;2
1040     SELECT Standard$
1050       CASE "Open"
1060         OUTPUT @Hp4294a;"COMA"
1070       CASE "Short"
1080         OUTPUT @Hp4294a;"COMB"
1090       CASE "Load"
1100         OUTPUT @Hp4294a;"COMC"
1110     END SELECT
1120     PRINT "Now measuring..."
1130 Meas_wait: GOTO Meas_wait
1140 Meas_end: !
1150     PRINT Standard$&" Data Measurement Complete"
1160     RETURN 0
1170   ELSE
1180     PRINT "Program Interruption"
1190     RETURN -1
1200   END IF
1210 FNEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      4/26/1999
5050   !* PROGRAM NAME: bsc_meas.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 1999 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
