10    !**************************************************************
20    !* 4294A + 16451B Permittivity Measurement (Non-Contact Method)
30    !* Instrument BASIC Sample Program
40    !**************************************************************
50    DIM Cp_data(1:801,1:2),D_data(1:801,1:2)
60    DIM Cp_data1(1:801,1:2),D_data1(1:801,1:2),Err_data(1:801,1:2)
70    DIM Cp_data2(1:801,1:2),D_data2(1:801,1:2),D_data3(1:801,1:2)
80    DIM Eri_data(1:801,1:2),Erm_data(1:801,1:2),Cole_data(1:801,1:2)
90    !
100   ASSIGN @Agt4294a TO 800
110   OUTPUT @Agt4294a;"DISA HIHB"
120   OUTPUT @Agt4294a;"HOLD"
130   !
140 Constants:   !
150   E0=8.854E-12
160   Adj_center=100000.
170   Adj_up_limit_a=1.E-9
180   Adj_low_limit_a=7.E-10
190   Adj_up_limit_b=2.E-11
200   Adj_low_limit_b=1.2E-11
210   Load_center=100000.
220   Load_ave=4
230   Load_bw=5
240   Load_up_limit_a=5.05E-11  ! [pF]
250   Load_lo_limit_a=4.95E-11
260   Load_up_limit_b=5.05E-12
270   Load_lo_limit_b=4.95E-12
280   Open_r=1.E+11             ! [ohm]
290   Open_l=0
300   Short_r=0
310   Short_l=0
320   Load_g=0
330   Nop=201
340   Ave=1
350   Bw=3
360   D_elec_a=.038             ! [m]
370   D_elec_b=.005
380   !########################################## Main
390 Disp_proc:!
400   CLEAR SCREEN
410   PRINT "4294A + 16451B Permittivity Measurement Program"
420   PRINT "  (Non-Contact Method Measurment)"
430   PRINT ""
440   PRINT "[ ]    Select the main electrode of 16451B"
450   PRINT "[ ]    Perform the adapter setup (1m cable)"
460   PRINT "[ ]    Adjust the electrodes (Parallelizing)"
470   PRINT "[ ]    Perform fixture compensation"
480   PRINT "x: done, s: skip, n: not required."
490   !
500 Adjustment: !
510   GOSUB Select_elec
520   GOSUB Adapter_setup
530   GOSUB Adjust
540   GOSUB Compen
550 Meas: !
560   GOSUB Input_t
570   GOSUB Input_d
580   DISP "Create the electrode gap Tg. Press 'Continue' when ready"
590   PAUSE
600   GOSUB Input_tg
610   DISP "Insert MUT between electrodes and press 'Continue'"
620   PAUSE
630   GOSUB Sweep
640   FOR I=1 TO Nop
650     FOR J=1 TO 2
660       Cp_data2(I,J)=Cp_data(I,J)
670       D_data2(I,J)=D_data(I,J)
680     NEXT J
690   NEXT I
700   DISP "Remove MUT and press 'Continue'"
710   PAUSE
720   GOSUB Sweep
730   FOR I=1 TO Nop
740     FOR J=1 TO 2
750      Cp_data1(I,J)=Cp_data(I,J)
760      D_data1(I,J)=D_data(I,J)
770     NEXT J
780   NEXT I
790   GOSUB Calc
800   GOTO Display
810   !########################################## Sub-routines
820 Select_elec: !
830   PRINT TABXY(5,4);"->"
840   DISP "Which electrode of 16451B is used?  0:A, 1:B";
850   INPUT "",Ans
860   SELECT Ans
870   CASE 0
880     Elec$="A"
890     Adj_up_limit=Adj_up_limit_a
900     Adj_low_limit=Adj_low_limit_a
910     Load_up_limit=Load_up_limit_a
920     Load_low_limit=Load_lo_limit_a
930   CASE 1
940     Elec$="B"
950     Adj_up_limit=Adj_up_limit_b
960     Adj_low_limit=Adj_low_limit_b
970     Load_up_limit=Load_up_limit_b
980     Load_low_limit=Load_lo_limit_b
990   CASE ELSE
1000    GOTO Select_elec
1010  END SELECT
1020  DISP "The electrode ";Elec$;" is selected. OK?   0:OK, 1:No";
1030  INPUT "",Ans
1040  IF Ans<>0 THEN Select_elec
1050  PRINT TABXY(2,4);"x]   "
1060  RETURN
1070  !
1080 Adapter_setup:!
1090  DISP "Perform the adapter setup?    0:Yes, 1:Skip";
1100  INPUT "",Ans
1110  IF Ans=1 THEN
1120    PRINT TABXY(2,5);"s]   "
1130    RETURN
1140  END IF
1150  F_adapt_setup=1
1160  OUTPUT @Agt4294a;"PRES"
1170  PRINT TABXY(5,5);"->"
1180  DISP "Set the 16451B OPEN condition and press 'Continue'."
1190  PAUSE
1200  DISP "Wait until the setup is finished."
1210  OUTPUT @Agt4294a;";E4TP OFF;E4TP M1;ECALP"
1220  OUTPUT @Agt4294a;"*OPC?"
1230  ENTER @Agt4294a;Opc
1240  OUTPUT @Agt4294a;";ECALDON"
1250  DISP ""
1260  PRINT TABXY(2,5);"x]   "
1270  RETURN
1280  !
1290 Adjust:!
1300  IF Elec$="C" OR Elec$="D" THEN
1310    PRINT TABXY(2,6);"n]   "
1320    RETURN
1330  END IF
1340  IF F_adapt_setup=0 THEN
1350    DISP "Perform the electrode adjustment?    0:Yes, 1:Skip";
1360    INPUT "",Ans
1370    IF Ans=1 THEN
1380      PRINT TABXY(2,6);"s]   "
1390      RETURN
1400    END IF
1410  END IF
1420  F_adjust=1
1430  PRINT TABXY(5,6);"->"
1440  OUTPUT @Agt4294a;"SWPT LIN"
1450  OUTPUT @Agt4294a;";CENT ";Adj_center
1460  OUTPUT @Agt4294a;";SPAN ";0
1470  OUTPUT @Agt4294a;";POIN ";2
1480  OUTPUT @Agt4294a;";;CALP USER"
1490  OUTPUT @Agt4294a;";MEAS CPD;TRAC A"
1500  OUTPUT @Agt4294a;"HIDI ON"
1510  OUTPUT @Agt4294a;"EDITLIML"
1520  OUTPUT @Agt4294a;";LIMCLEL ;LIMSADD"
1530  OUTPUT @Agt4294a;";LIMSTAR ";Adj_center
1540  OUTPUT @Agt4294a;";LIMSTOP ";Adj_center
1550  OUTPUT @Agt4294a;";LIMLSTAR ";Adj_low_limit
1560  OUTPUT @Agt4294a;";LIMUSTAR ";Adj_up_limit
1570  OUTPUT @Agt4294a;";LIMLSTOP ";Adj_low_limit
1580  OUTPUT @Agt4294a;";LIMUSTOP ";Adj_up_limit
1590  OUTPUT @Agt4294a;";LIMSDON;;LIMEDONE"
1600  OUTPUT @Agt4294a;";TOPV ";1.5*Adj_up_limit-.5*Adj_low_limit
1610  OUTPUT @Agt4294a;";BOTV ";1.5*Adj_low_limit-.5*Adj_up_limit
1620  !
1630  OUTPUT @Agt4294a;"LIMITEST OFF"
1640  DISP "Set the micrometer of 16451B at 10um and press 'Continue'."
1650  PAUSE
1660  OUTPUT @Agt4294a;"LIMITEST ON"
1670  OUTPUT @Agt4294a;"CONT"
1680  OUTPUT @Agt4294a;";MKR ON"
1690  DISP "Adjust the electrode until PASS is displayed."
1700  PAUSE
1710  OUTPUT @Agt4294a;"HOLD"
1720  OUTPUT @Agt4294a;"OUTPFAIP?"
1730  ENTER @Agt4294a;F_nop
1740  IF F_nop<>0 THEN Adj
1750  OUTPUT @Agt4294a;"LIMITEST OFF"
1760  PRINT TABXY(2,6);"x]   "
1770  RETURN
1780  !
1790 Compen:!
1800  IF F_adjust=0 THEN
1810    DISP "Perform the fixture compensation?    0:Yes, 1:Skip";
1820    INPUT "",Ans
1830    IF Ans=1 THEN
1840      PRINT TABXY(2,7);"s]   "
1850      RETURN
1860    END IF
1870  END IF
1880  PRINT TABXY(4,7);"->"
1890 Input_config:!
1900  DISP "Start frequency [Hz] = ?";
1910  INPUT "",Start
1920  DISP "Stop frequency [Hz] = ?";
1930  INPUT "",Stop
1940  DISP "Sweep type?   0:Linear, 1:Log";
1950  INPUT Ans
1960  IF Ans=1 THEN
1970    Swe_type$="LOG"
1980  ELSE
1990    Swe_type$="LIN"
2000  END IF
2010  DISP "OSC level [V] =?";
2020  INPUT "",Vosc
2030  DISP "Number of point?   [2-801]";
2040  INPUT Nop
2050  PRINT TABXY(1,10);"Start: ";Start;"[Hz]  Stop: ";Stop;"[Hz]";"  Nop: ";Nop
2060  PRINT TABXY(1,11);"Sweep Type: ";Swe_type$;"  OSC Level: ";Vosc;"[V]";
2070  DISP "Measurement condition is OK?       0:OK, 1:NO";
2080  INPUT "",Ans
2090  IF Ans<>0 THEN Input_config
2100  !
2110  OUTPUT @Agt4294a;";;CALP USER"
2120  OUTPUT @Agt4294a;";MEAS CPD;TRAC A"
2130  OUTPUT @Agt4294a;"SWPT LIN"
2140  OUTPUT @Agt4294a;";CENT ";Load_center
2150  OUTPUT @Agt4294a;"SPAN 0"
2160  OUTPUT @Agt4294a;";POIN ";2
2170  OUTPUT @Agt4294a;"BWFACT ";Load_bw
2180  OUTPUT @Agt4294a;";PAVER ON;PAVERFACT ";Load_ave
2190  OUTPUT @Agt4294a;"LIMITEST ON;EDITLIML"
2200  OUTPUT @Agt4294a;";LIMCLEL ;LIMSADD"
2210  OUTPUT @Agt4294a;";LIMSTAR ";Load_center
2220  OUTPUT @Agt4294a;";LIMSTOP ";Load_center
2230  OUTPUT @Agt4294a;";LIMLSTAR ";Load_low_limit
2240  OUTPUT @Agt4294a;";LIMUSTAR ";Load_up_limit
2250  OUTPUT @Agt4294a;";LIMLSTOP ";Load_low_limit
2260  OUTPUT @Agt4294a;";LIMUSTOP ";Load_up_limit
2270  OUTPUT @Agt4294a;";LIMSDON;;LIMEDONE"
2280  OUTPUT @Agt4294a;"TOPV ";1.5*Load_up_limit-.5*Load_low_limit
2290  OUTPUT @Agt4294a;"BOTV ";1.5*Load_low_limit-.5*Load_up_limit
2300  OUTPUT @Agt4294a;"HIDI ON"
2310  !
2320 Load_adj:!
2330  OUTPUT @Agt4294a;"CONT"
2340  OUTPUT @Agt4294a;";MKR ON"
2350  DISP "Turn the micrometer's knob until PASS is displayed."
2360  PAUSE
2370  OUTPUT @Agt4294a;"HOLD"
2380  OUTPUT @Agt4294a;"OUTPFAIP?"
2390  ENTER @Agt4294a;F_nop
2400  IF F_nop<>0 THEN Load_adj
2410  DISP ""
2420  OUTPUT @Agt4294a;"LIMITEST OFF"
2430  OUTPUT @Agt4294a;"OUTPDTRCP? 1"
2440  ENTER @Agt4294a;Load_c
2450  !
2460  OUTPUT @Agt4294a;";STAR ";Start
2470  OUTPUT @Agt4294a;";STOP ";Stop
2480  OUTPUT @Agt4294a;";SWPT ";Swe_type$
2490  OUTPUT @Agt4294a;"POIN ";Nop
2500  OUTPUT @Agt4294a;";BWFACT ";Bw
2510  OUTPUT @Agt4294a;";POWMOD VOLT;POWE ";Vosc
2520  OUTPUT @Agt4294a;"DCOMOPENG ";Load_g
2530  OUTPUT @Agt4294a;"DCOMOPENC ";Load_c/1.E-15
2540  OUTPUT @Agt4294a;"DCOMSHORR ";Short_r
2550  OUTPUT @Agt4294a;"DCOMSHORL ";Short_l
2560  OUTPUT @Agt4294a;"DCOMLOADR ";Open_r
2570  OUTPUT @Agt4294a;"DCOMLOADL ";Open_l
2580  !
2590  OUTPUT @Agt4294a;"COMA"
2600  DISP "Now measuring LOAD..."
2610  OUTPUT @Agt4294a;"*OPC?"
2620  ENTER @Agt4294a;Opc
2630  DISP "Set 16451B OPEN condition and press 'Continue'."
2640  PAUSE
2650  OUTPUT @Agt4294a;";COMC"
2660  DISP "Now measuring OPEN..."
2670  OUTPUT @Agt4294a;"*OPC?"
2680  ENTER @Agt4294a;Opc
2690  DISP "Set 16451B SHORT condition and press 'Continue'."
2700  PAUSE
2710  DISP "Now measuring SHORT..."
2720  OUTPUT @Agt4294a;";COMB"
2730  OUTPUT @Agt4294a;"*OPC?"
2740  ENTER @Agt4294a;Opc
2750  DISP ""
2760  PRINT TABXY(2,7);"x]   "
2770  RETURN
2780  !
2790 Input_t:!
2800  DISP "Thickness of MUT [mm] = ?";
2810  INPUT "",Ans
2820  T_dut=Ans/1000
2830  RETURN
2840  !
2850 Input_tg:!
2860  DISP "Distance of Electrode Gap Tg [mm] = ?";
2870  INPUT "",Ans
2880  Tg=Ans/1000
2890  RETURN
2900  !
2910 Input_d:!
2920  SELECT Elec$
2930  CASE "A"
2940    D_elec=D_elec_a
2950  CASE "B"
2960    D_elec=D_elec_b
2970  END SELECT
2980  RETURN
2990  !
3000 Sweep: !
3010  OUTPUT @Agt4294a;"DISA BASS"
3020  OUTPUT @Agt4294a;"MEAS CPD"
3030  OUTPUT @Agt4294a;"HIDI OFF"
3040  OUTPUT @Agt4294a;"SING"
3050  DISP "Now measuring Cp-D..."
3060  OUTPUT @Agt4294a;"*OPC?"
3070  ENTER @Agt4294a;Opc
3080  DISP "Now getting data..."
3090  OUTPUT @Agt4294a;"TRAC A"
3100  OUTPUT @Agt4294a;"AUTO"
3110  OUTPUT @Agt4294a;"OUTPDTRC?"
3120  ENTER @Agt4294a USING "%,K";Cp_data(*)
3130  OUTPUT @Agt4294a;"TRAC B"
3140  OUTPUT @Agt4294a;"AUTO"
3150  OUTPUT @Agt4294a;"OUTPDTRC?"
3160  ENTER @Agt4294a USING "%,K";D_data(*)
3170  RETURN
3180  !
3190 Calc:  !
3200  FOR I=1 TO Nop
3210    D_data3(I,1)=(D_data2(I,1)+Err_data(I,1)*(D_data2(I,1)-D_data1(I,1))*((Tg/T_dut)-1))
3220    D_data3(I,2)=0
3230    Err_data(I,1)=1/(1-(1-(Cp_data1(I,1)/Cp_data2(I,1)))*(Tg/T_dut))
3240    Err_data(I,2)=0
3250    Eri_data(I,1)=Err_data(I,1)*D_data3(I,1)
3260    Eri_data(I,2)=0
3270    Erm_data(I,1)=SQR(Err_data(I,1)^2+Eri_data(I,1)^2)
3280    Erm_data(I,2)=0
3290    Cole_data(I,1)=Err_data(I,1)
3300    Cole_data(I,2)=Eri_data(I,1)
3310  NEXT I
3320  RETURN
3330  !
3340 Display:!
3350  ON KEY 1 LABEL "er' -          tan d",1 GOSUB Disp_er_d
3360  ON KEY 2 LABEL "|er| -         tan d",1 GOSUB Disp_em_d
3370  ON KEY 3 LABEL "er' -           er''",1 GOSUB Disp_er_ei
3380  ON KEY 4 LABEL "Cole-cole       Plot",1 GOSUB Disp_cole
3390  ON KEY 7 LABEL "Quit",1 GOTO Quit
3400  ON KEY 8 LABEL "Re-measure",1 GOTO Re_meas
3410  OUTPUT @Agt4294a;"USKEY"
3420  BEEP
3430  DISP "Select softkey to display each parameter."
3440 Loop: GOTO Loop
3450  !
3460 Disp_er_d: !
3470  DISP "Now loading data..."
3480  OUTPUT @Agt4294a;"MEAS CPD"
3490  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3500  OUTPUT @Agt4294a;"TRAC A"
3510  OUTPUT @Agt4294a;"INPUDTRC ";
3520  FOR I=1 TO Nop
3530    OUTPUT @Agt4294a;Err_data(I,1),Err_data(I,2);
3540  NEXT I
3550  OUTPUT @Agt4294a;""
3560  OUTPUT @Agt4294a;"AUTO"
3570  OUTPUT @Agt4294a;"TRAC B"
3580  FOR I=1 TO Nop
3590    OUTPUT @Agt4294a;"INPUDTRC ";
3600    OUTPUT @Agt4294a;D_data3(I,1),D_data3(I,2);
3610  NEXT I
3620  OUTPUT @Agt4294a;""
3630  OUTPUT @Agt4294a;"AUTO"
3640  OUTPUT @Agt4294a;"TRAC A"
3650  BEEP
3660  DISP "A: er'  B: tan d  /  Thickness: ";T_dut*1000;"[mm]"
3670  RETURN
3680  !
3690 Disp_em_d: !
3700  DISP "Now loading data..."
3710  OUTPUT @Agt4294a;"MEAS CPD"
3720  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3730  OUTPUT @Agt4294a;"TRAC A"
3740  OUTPUT @Agt4294a;"INPUDTRC ";
3750  FOR I=1 TO Nop
3760    OUTPUT @Agt4294a;Erm_data(I,1),Erm_data(I,2);
3770  NEXT I
3780  OUTPUT @Agt4294a;""
3790  OUTPUT @Agt4294a;"AUTO"
3800  OUTPUT @Agt4294a;"TRAC B"
3810  FOR I=1 TO Nop
3820    OUTPUT @Agt4294a;"INPUDTRC ";
3830    OUTPUT @Agt4294a;D_data3(I,1),D_data3(I,2);
3840  NEXT I
3850  OUTPUT @Agt4294a;""
3860  OUTPUT @Agt4294a;"AUTO"
3870  OUTPUT @Agt4294a;"TRAC A"
3880  BEEP
3890  DISP "A: |er|  B: tan d  /  Thickness: ";T_dut*1000;"[mm]"
3900  RETURN
3910  !
3920 Disp_er_ei: !
3930  DISP "Now loading data..."
3940  OUTPUT @Agt4294a;"MEAS CPD"
3950  OUTPUT @Agt4294a;"HIDI OFF;SPLD ON"
3960  OUTPUT @Agt4294a;"TRAC A"
3970  OUTPUT @Agt4294a;"INPUDTRC ";
3980  FOR I=1 TO Nop
3990    OUTPUT @Agt4294a;Err_data(I,1),Err_data(I,2);
4000  NEXT I
4010  OUTPUT @Agt4294a;""
4020  OUTPUT @Agt4294a;"AUTO"
4030  OUTPUT @Agt4294a;"TRAC B"
4040  FOR I=1 TO Nop
4050    OUTPUT @Agt4294a;"INPUDTRC ";
4060    OUTPUT @Agt4294a;Eri_data(I,1),Eri_data(I,2);
4070  NEXT I
4080  OUTPUT @Agt4294a;""
4090  OUTPUT @Agt4294a;"AUTO"
4100  OUTPUT @Agt4294a;"TRAC A"
4110  BEEP
4120  DISP "A: er'  B: er''  /  Thickness: ";T_dut*1000;"[mm]"
4130  RETURN
4140  !
4150 Disp_cole: !
4160  DISP "Now loading data..."
4170  OUTPUT @Agt4294a;"MEAS COMP"
4180  OUTPUT @Agt4294a;"HIDI ON;SPLD OFF"
4190  OUTPUT @Agt4294a;"TRAC A"
4200  OUTPUT @Agt4294a;"INPUDTRC ";
4210  FOR I=1 TO Nop
4220    OUTPUT @Agt4294a;Cole_data(I,1),Cole_data(I,2);
4230  NEXT I
4240  OUTPUT @Agt4294a;""
4250  OUTPUT @Agt4294a;"AUTO"
4260  BEEP
4270  DISP "Cole-cole Plot     Thickness: ";T_dut*1000;"[mm]"
4280  RETURN
4290  !
4300 Re_meas: !
4310  DISP "Measure once more?        0:Yes, 1:Cancel";
4320  INPUT "",Ans
4330  SELECT Ans
4340  CASE 0
4350    GOTO Meas
4360  CASE 1
4370    GOTO Display
4380  CASE ELSE
4390    GOTO Re_meas
4400  END SELECT
4410  !
4420 Quit: !
4430  DISP "Really quit the program?     0:Yes, 1:Cancel";
4440  INPUT "",Ans
4450  SELECT Ans
4460  CASE 0
4470    DISP "Bye."
4480  CASE 1
4490    GOTO Display
4500  CASE ELSE
4510    GOTO Quit
4520  END SELECT
4530  END
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4294A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      3/21/2000
5050   !* PROGRAM NAME: permi_nc.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*    Copyright (c) 2000 Agilent Technologies,
5090   !*             All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
